<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2020 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2019-01-08
 */
define('IN_DOUCO', true);

$sub = 'intro|rank|submit|view';
$subbox = array(
        "module" => 'vote',
        "sub" => $sub
);

$_CUR = 'vote';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 验证并获取合法REQUEST
$vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/vote.class.php');
$vote = new Vote();

// 获取投票信息
$vote_info = $dou->get_row('vote', '*', "vote_id = '$vote_id' AND status = '1'");

if ($vote_info) {
    // 格式化数据
    $vote_info['start_time'] = date("Y-m-d H:i:s", $vote_info['start_time']);
    $vote_info['end_time'] = date("Y-m-d H:i:s", $vote_info['end_time']);
    $vote_info['max_vote_number_text'] = preg_replace('/d%/Ums', $vote_info['max_vote_number'], $_LANG['vote_max_vote_number']);

    // 链接
    $vote_info['url_vote'] = $dou->param($dou->rewrite_url('vote') . '&vote_id=' . $vote_id);
    $vote_info['url_rank'] = $dou->param($dou->rewrite_url('vote', 'rank') . '&vote_id=' . $vote_id);
    $vote_info['url_intro'] = $dou->param($dou->rewrite_url('vote', 'intro') . '&vote_id=' . $vote_id);
}

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'vote', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 投票
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    if (!$vote_info)
        $dou->dou_msg($GLOBALS['_LANG']['page_wrong'], ROOT_URL);

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('vote_option') . " WHERE vote_id = '$vote_id' ORDER BY sort ASC, number ASC, option_id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, ($_DISPLAY['vote'] ? $_DISPLAY['vote'] : 12), $page, $dou->rewrite_url('vote'));

    /* 获取资质证书列表 */
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $poll = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$row[option_id]'"));
        
        $vote_option_list[] = array (
                "option_id" => $row['option_id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "content" => $row['content'],
                "number" => $row['number'] . $_LANG['vote_option_number_unit'],
                "poll" => $poll,
                "url" => $dou->param($dou->rewrite_url('vote', 'view') . '&vote_id=' . $row['vote_id'] . '&option_id=' . $row['option_id']),
                "ip_voted" => $vote->check_ip_voted($row['option_id'])
        );
    }
 
    // 访问统计
    $click = $vote_info['click'] + 1;
    $dou->query("UPDATE " . $dou->table('vote') . " SET click = '$click' WHERE vote_id = '$vote_id'");
 
    // 投票状态
    $vote_info['time_status'] = $vote->vote_time_status($vote_id);

    // 判断投票是否结束
    if ($vote->check_vote_ended($vote_option['vote_id']))
        $vote_info['ended'] = true;
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('page', '', $vote_info['name']));
    $smarty->assign('ur_here', $dou->ur_here('page', '', $vote_info['name']));
    $smarty->assign('head', $vote_info['name']);
    $smarty->assign('vote_option_list', $vote_option_list);
    $smarty->assign('vote_info', $vote_info);
    $smarty->assign('count_vote', $vote->count_vote($vote_id));

    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 投票介绍页
 * +----------------------------------------------------------
 */
if ($rec == 'intro') {
    if (!$vote_info)
        $dou->dou_msg($GLOBALS['_LANG']['page_wrong'], ROOT_URL);

    $vote_info['qrcode'] = $vote->qrcode($vote_id);
 
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('page', '', $vote_info['name']));
    $smarty->assign('ur_here', $dou->ur_here('page', '', $vote_info['name']));
    $smarty->assign('head', $vote_info['name']);
    $smarty->assign('vote_info', $vote_info);
    $smarty->assign('count_vote', $vote->count_vote($vote_id));
 
    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 排行榜
 * +----------------------------------------------------------
 */
if ($rec == 'rank') {
    if (!$vote_info)
        $dou->dou_msg($GLOBALS['_LANG']['page_wrong'], ROOT_URL);

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('vote_option') . " WHERE vote_id = '$vote_id' ORDER BY sort ASC, number ASC, option_id DESC";

    /* 获取资质证书列表 */
    $sql = $sql; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $poll = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$row[option_id]'"));
        
        $vote_option_list[] = array (
                "option_id" => $row['option_id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "content" => $row['content'],
                "number" => $row['number'] . $_LANG['vote_option_number_unit'],
                "poll" => $poll,
                "ip_voted" => $vote->check_ip_voted($row['option_id'])
        );
    }
 
    // 重新排序
    array_multisort($vote->array_column($vote_option_list, 'poll'), SORT_DESC, $vote_option_list);

    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('page', '', $_LANG['vote_rank']));
    $smarty->assign('ur_here', $dou->ur_here('page', '', $_LANG['vote_rank']));
    $smarty->assign('head', $_LANG['vote_rank']);
    $smarty->assign('vote_option_list', $vote_option_list);
    $smarty->assign('vote_info', $vote_info);

    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 候选人介绍
 * +----------------------------------------------------------
 */
if ($rec == 'view') {
    $option_id = $check->is_number($_REQUEST['option_id']) ? $_REQUEST['option_id'] : 0;
 
    // 候选信息
    $vote_option = $dou->get_row('vote_option', '*', "option_id = '$option_id'");
    if (!$vote_option)
        $dou->dou_msg($GLOBALS['_LANG']['page_wrong'], ROOT_URL);

    // 格式化数据
    $vote_option['number'] = $vote_option['number'] . $_LANG['vote_option_number_unit'];
    $vote_option['image'] = $dou->dou_file($vote_option['image']);
    $vote_option['content'] = $vote->line_break($vote_option['content']);
    $vote_option['ip_voted'] = $vote->check_ip_voted($option_id);
    $vote_option['poll'] = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$option_id'"));
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('page', '', $vote_option['name']));
    $smarty->assign('ur_here', $dou->ur_here('page', '', $vote_option['name']));
    $smarty->assign('head', $vote_option['name']);
    $smarty->assign('vote_info', $vote_info);
    $smarty->assign('vote_option', $vote_option);
 
    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 投票
 * +----------------------------------------------------------
 */
elseif ($rec == 'submit') {
    $option_id = $check->is_number($_POST['option_id']) ? $_POST['option_id'] : 0;
    if (!$dou->value_exist('vote_option', 'option_id', $option_id))
        exit;

    // 候选信息
    $vote_option = $dou->get_row('vote_option', '*', "option_id = '$option_id'");
    
    // 格式化数据
    $ip = $dou->get_ip();
    $vote_time = time();
 
    // 判断投票是否开始
    if ($vote->check_vote_nostart($vote_option['vote_id']))
        die($_LANG['vote'] . $_LANG['vote_status_nostart']);
    
    // 判断投票是否结束
    if ($vote->check_vote_ended($vote_option['vote_id']))
        die($_LANG['vote'] . $_LANG['vote_status_ended']);
    
    // 判断IP是否已经投过票
    if ($vote->check_ip_voted($vote_option['option_id']))
        die($_LANG['vote_ip_voted']);
    
    // 判断IP是否已经投过票
    if ($vote->check_ip_voted($vote_option['option_id']))
        die($_LANG['vote_ip_voted']);
    
    // 验证每个IP最大投票数
    if ($max_vote_number = $vote->check_out_max_vote_number($vote_option['vote_id'], $ip))
        die($max_vote_number);
    
    $sql = "INSERT INTO " . $dou->table('vote_log') . " (id, vote_id, option_id, ip, vote_time)" . " VALUES (NULL, '$vote_option[vote_id]', '$vote_option[option_id]', '$ip', '$vote_time')";
    $dou->query($sql);
    
    // 当前排名
    $rank = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$vote_option[option_id]'"));
 
    // 返回AJAX
    echo $rank;
}

?>